import processing.core.*; 
import processing.xml.*; 

import guicomponents.*; 
import java.math.BigDecimal; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class LayerCake extends PApplet {




GLabel lBin, lConf, lDip, lEvent, lStripe, wVlabel, wClabel, lCoverage;
GWSlider sBin, sConf, sEvent;
GTextField tConf, tEvent, tBin;
GTextField tstart, tend;
//GImageButton btnOpen, btnSave;
GButton btnOpen, btnSave;

GCheckbox temp1;
GOption temp2;

GCheckbox stripeCheck;
GCheckbox synomCheck;
GCheckbox nonsynomCheck;
GCheckbox coverageCheck;

char[][] refgen;
HashMap codonlookup;
int[] rowcolors;
String[] metadata;
//raw data: variation %
float [][][] vraw;
double [][][] praw;
int[][] covraw;
int maxcovraw = 0;
int maxcovdisp = 0;

//display
int[][] covdisp;
float [][] vdisp;
double [][] pdisp;


float[] vhist;

//visibility

// reference : location : is this amino acid synom. with the reference?
boolean[][][] synom;
boolean[][] gaps;

//orf information
int[] starts;
int[]ends;
int[] depths;
String[] orfNames;

GOption[] reference;

float bw = 10;
float bh = 200;
int rows = -1;
int cols = -1;
int rgap = 10;
int cgap = 0;

float xtrans = 0;
float ytrans = 0;
float oldx = 0;
float oldy = 0;

int maxcount = 0;
float maxn = 0;
float maxdip = 0;
float maxvariant = 0;
float maxrawvariant = 0;

int mode = 0;
float vweight = .9f;
float eweight = .80f;
int row = 0;
int col = 0;
int minrt = 999999;
int maxrt = -1;
int minminrt = 999999;
int maxmaxrt = -1;
int minwidth = 60;
float ratio = 10;
int editmode = 0;
int winWidth = 0;
int winHeight = 0;
int slWidth = 0;
int slGap = 0;
PFont font;
public static int switchvar = 0;
int dataWidth;
int dataX = 130;
int binBasePairs = minwidth;
char[] atcgOrder = new char[] {
  'A', 'T', 'C', 'G'
};
int[] actgcolor = new int[] {
  color(102, 194, 165), color(141, 160, 203), color(231, 138, 195), color(166, 216, 84), color(255)
};
int zoomBin = -1;
float zoomS = 0;
float zoomW = 0;
float bpw = 0;
float oldbw = 0;
int rawcol = -1;
int minBasePairs = 1;
int prevBinMax = 0;
int prevBinVal = 0;
int maxZoomedBinSize = 0;
int numBins = 0;
int dataY = 90;
int sideGraphWidth = 200;
float initbh = 0;
int[] events;

int left = color(255, 255, 204);  //yellow - 60  .167  .2   1
int left10  = color(255, 246, 176);
int left20  = color(255, 230, 148);  //         .128,.42,1
int left30  = color(252, 205, 116);
int left40 =  color(255, 176, 88);  //         .095,.84,.1
int mid =  color(253, 141, 60);  //orange -  25  .069  .76  .99
int right60 =  color(227, 92, 43);   //          .02,.57,.87
int right70 =  color(201, 51, 28);
int right80 =  color(179, 18, 21);
int right90 =  color(153, 8, 29);
int right = color(128, 0, 38);  //red    - 342  .95  1     .5


int  bottom = color(200);
int maxcolor = color(194, 0, 0);  // .95 1 .76

int[] coloroptions = new int[] {
  bottom, color(128), color(255, 127, 0), color(0, 0, 255, 128)
};

//--------Wedge vars----------------
Wedge wedge;
int tipcolor = color(243, 221, 73);
int eventcolor = color(255, 0, 0);
int wedgeX = 0;
int wedgeY = 0;
int wedgewidthonscreen = 90;
float prevValue = 0.7f;
float wedgeratio = 1;
GLabel perV0, perV1, perC0, perC1;

//--------Row Interchange--------------
boolean pressed; 
int visibleCount = 0;
int selectedRow = -1;
int draggedRow = 0;
int[] reorder;

//Row reference
int refRow = -1;
GOptionGroup optRef;

public void setup() {

  //winWidth = int(min(5000,screen.width-250));
  //winHeight = int(min(1000,screen.height-150));

  size(1400, 1000);
  winWidth = 1400;
  winHeight = 1000;
  //size(winWidth,winHeight);

  dataWidth = (winWidth-dataX)-25 - sideGraphWidth;
  rectMode(CORNER);
  oldx = mouseX;
  oldy = mouseY;

  font = loadFont("Calibri-14.vlw");
  textFont(font, 14);
  bpw = textWidth('G'+"");
  slWidth = winWidth/3;
  slGap = slWidth*3/5;

  GComponent.globalFont = GFont.getFont(this, "Calibri", 12);

  new GLabel(this, "Show Synon. Var.", 430 +slWidth, winHeight - 120, 120);
  synomCheck = new GCheckbox(this, "", 555 +slWidth, winHeight - 120, 100);
  synomCheck.setSelected(true);

  new GLabel(this, "Show Non-Synon. Var.", 430 +slWidth, winHeight - 100, 120);
  nonsynomCheck = new GCheckbox(this, "", 555 +slWidth, winHeight - 100, 100);
  nonsynomCheck.setSelected(true);


  //String fname = selectInput("Select a .tsv file...");

  /*
  String fname = selectFolder("Select a folder of .csv files...");
   //System.err.println(fname);
   if(fname==null){
   fname = dataPath("TestData");
   }//end if
   loadDir(fname);
   */
  loadTest();
  //vdisp = vraw;
  //String reffname = "./data/sivmac239_proteins.csv";



  reference = new GOption[rows+2];
  visibleCount = rows;
  codonlookup = new HashMap();

  //print ("vraw size=" + vraw[2].length);
  noStroke();
  bh = ((winHeight- 160 - dataY)/PApplet.parseFloat(rows))-rgap;      // adjust space for sliders
  bw = ((dataWidth/PApplet.parseFloat(cols))-cgap);
  oldbw = bw;
  reorder = new int[rows];
  for (int i = 0;i<reorder.length;i++) {
    reorder[i] = i;
  }
  int numBins = ceil((maxrt-minrt)/binBasePairs);
  minBasePairs = ceil((maxrt-minrt)/dataWidth);  //each bin gets atleast 1 pixel
  int maxBasePairs = floor(PApplet.parseFloat(dataWidth-rows+1)/bpw);

  bw = (dataWidth/PApplet.parseFloat(numBins))-cgap;
  if (bw>=1) {
    sample(binBasePairs);
  }
  else {
    sample(minBasePairs);
    bw = 1;
    //println(bw + "--" + minBasePairs);
  }
  oldbw = bw;


  sBin = new GWSlider(this, 345, winHeight - 120, slGap);
  lBin = new GLabel(this, "Bin Size (bp)", 240, winHeight - 120, 120);  
  sBin.setLimits(minwidth, minBasePairs, maxBasePairs);
  sBin.setValueType(GWSlider.INTEGER);
  prevBinMax = 160;
  prevBinVal = minwidth;

  sConf = new GWSlider(this, 345, winHeight - 80, slGap);
  lConf = new GLabel(this, "-log(Alpha)", 240, winHeight - 80, 120);
  sConf.setValueType(GWSlider.INTEGER);
  sConf.setLimits( 1, 1, 70);
  tConf = new GTextField(this, "1", 345 + slGap + 15, winHeight - 84, 40, 15);
  sConf.setRenderValueLabel(false); //hides labels  

  //--------------------------------------

  lEvent = new GLabel(this, "Event Threshold", 300+slWidth, winHeight - 80, slGap);
  sEvent = new GWSlider(this, 430+slWidth, winHeight - 80, slGap);
  sEvent.setLimits(.9f, 0, 1.0f );
  sEvent.setValueType(GWSlider.DECIMAL);
  sEvent.setRenderValueLabel(false); //hides labels
  tEvent = new GTextField(this, str(0.9f), 430+slWidth + slGap + 15, winHeight - 84, 40, 15);  
  //--------------------------------------

  lStripe = new GLabel(this, "Event Striping", 300 +slWidth, winHeight - 120, 120);
  stripeCheck = new GCheckbox(this, "", 400 +slWidth, winHeight - 120, 100);

  lCoverage = new GLabel(this, "Show Coverage", 300 +slWidth, winHeight - 100, 120);
  coverageCheck = new GCheckbox(this, "", 400 +slWidth, winHeight - 100, 100);
  coverageCheck.setSelected(false);

  new GLabel(this, "Data Limits", 625 +slWidth, winHeight - 120, 120);
  tstart = new GTextField(this, str(minrt), 700 +slWidth, winHeight - 120, 40, 15);
  tend = new GTextField(this, str(maxrt), 750 +slWidth, winHeight - 120, 40, 15);


  //WEDGE IN HERE ***************************          WEDGE      ********************************
  //setup wedge - xpos/ypos/size any link??
  wedgewidthonscreen = 80;
  wedgeX = 30 +   wedgewidthonscreen;        //winWidth - wedgewidthonscreen;
  wedgeY = winHeight - 15;
  wedge = new Wedge(wedgeX, wedgeY, 270);
  wedge.right = vweight;
  wedge.left=0;

  //-------------------------------------------------------------------
  ////////////////////// VISIBILITY PANEL ////////////////////
  //-----------------------------------------------------------------
  optRef = new GOptionGroup(this);
  reference[0] = new GOption(this, "Reference", 0, 10, 120);

  optRef.addOption(reference[0]);
  reference[0].setSelected(true);

  //reference[i] = 
  initbh = bh;
  for (int i = 0;i<vdisp.length;i++) {
    reference[i+1] = new GOption(this, "", 5, PApplet.parseInt(dataY+ i*(bh+rgap))-5, 15);
    optRef.addOption(reference[i+1]);
  }

  setupcodontable();
  //calcReferenceGenome();
  //loadProteinOverlay();
}//end setup

//-------------------------------------------------------------------
////////////////////// DRAW FUNCTIONS START HERE ////////////////////
//-----------------------------------------------------------------
public void draw() {
  if (mode==0) {
    drawEven(false);
  }//end if
  else if (mode==2) {
    drawEven(true);
  }//end if

  //MORE WEDGES ---------------------
  wedge.draw();
  if (zoomBin!=-1) {
    text("100%", wedgeX + 100, wedgeY - 125);
    text( toPercentFloat(wedge.right), wedge.posX(wedge.right, 1.0f), wedge.posY(wedge.right, 1.0f)-5);
  }
  else {
    text( toPercentFloat(maxvariant), wedgeX + 100, wedgeY-125);
    text( toPercentFloat(maxvariant*wedge.right), wedge.posX(wedge.right, 1.0f), wedge.posY(wedge.right, 1.0f)-5);
  }
  text( toPercentFloat(maxvariant*wedge.left), wedge.posX(wedge.left, 1.0f), wedge.posY(wedge.left, 1.0f)-5);
  text("100%", wedgeX + 90, wedgeY - 90);    
  text("1-1E-"+sConf.getValue()+"%", wedgeX + textWidth("1-1E-"+sConf.getValue()+"%"), wedgeY - 3);    
  text("Variant(%)", wedgeX, wedgeY - 145);
  text("Conf(%)", wedgeX + 55, wedgeY - 40);

  //-----------------------------------
  rawcol = -1;
  if (zoomBin>=0) {
    if (mouseX< winWidth - 2*wedgewidthonscreen) {
      if ((mouseX-xtrans-dataX)<=zoomS) {
        col = floor( (mouseX-xtrans-dataX)/(bw+cgap));
      }
      else if ((mouseX-xtrans-dataX)>=zoomS+zoomW) {
        col =  floor( (mouseX-xtrans-dataX-zoomS-zoomW)/ (bw+cgap)) + (zoomBin+1);
      }
      if ((mouseX-xtrans-dataX)>zoomS && (mouseX-xtrans-dataX)<zoomS+zoomW) {
        rawcol = (zoomBin*binBasePairs) +  floor( (mouseX-xtrans-dataX-zoomS)/ (bpw+cgap)) + (minrt-minminrt);
      }
    }
  }//end if
  else {
    col = floor( (mouseX-xtrans-dataX)/(bw+cgap));
  }
  row = floor((mouseY-ytrans-dataY)/(bh+rgap));
  if (row>=0 && row<reorder.length) {
    row = reorder[row];
  }
  drawSideGraph(); 
  drawTooltip();
}//end draw

public void drawEven(boolean drawStripes) {
  int textGap = PApplet.parseInt(textWidth(maxrt+" ")/oldbw)+1;
  pushMatrix();
  background(225);
  //background(hue(bottom),saturation(bottom),brightness(bottom)+50);

  //this is for the top event legend
  noStroke();
  fill(0);
  text("Ref_nt:", dataX-textWidth("Ref_nt:"), 12);
  events = new int[vdisp[0].length];
  for (int i = 0;i<vdisp[0].length;i++) {
    if (i%2==0)
      fill(150);
    else
      fill(70);
    rect(dataX + i*oldbw, 15, oldbw, 10);
    if (i%textGap==0) {
      fill(0);
      text(i*binBasePairs + minrt, dataX + i*oldbw, 12);
    }
    else if (i==vdisp[0].length-1) {
      fill(0);
      // text(maxrt,dataX + i*oldbw + (textWidth(maxrt+"")/2.0), 12);
    }
    events[i] = 0;
  } 


  drawORF();
  //draw trapezium
  noStroke();
  //int maxZoomBins = floor(float(dataWidth - (numBins-1))/bpw);  //instead of 1 it should be the current non-zoom width
  // sBin.setLimits(min(maxZoomBins,prevBinVal),9,maxZoomBins);

  if (zoomBin>=0) {
    //println(binBasePairs);
    binBasePairs = max(1, sBin.getValue());
    numBins = ceil((maxrt-minrt)/binBasePairs);
    fill(100);
    quad(dataX + (zoomBin)*oldbw, 75, dataX + zoomS, dataY-rgap, dataX + zoomS + zoomW, dataY-rgap, ceil(dataX + (zoomBin+1)*oldbw), 75 );
    fill(100, 128);
    rect(dataX + (zoomBin)*oldbw, 15, oldbw, 60);
    zoomW = binBasePairs*bpw;
    bw = ((dataWidth-zoomW)/(cols-1.0f))-cgap;
    zoomS = (bw+cgap)*zoomBin;
    drawBin();
  }



  translate(xtrans+dataX, ytrans);
  float h = (bh/ratio);
  float curx = 0;
  float cury = 0;
  int vmask = 0;
  //println(vdisp[0].length);
  // INCASE the reference changes


  int i = 0;				
  for (int l = 0;l<vdisp.length;l++) {
    i = reorder[l];
    curx = 0;
    for (int j =0;j<vdisp[i].length;j++) {
      if (j==zoomBin) {
        curx+=zoomW;
      }
      else {  
        float refVar = vdisp[i][j];// - newRefRow[j];  		
        if (refVar>=0) {
          double cer = pdisp[i][j];
          fill(getColor(refVar, cer, maxvariant));
          rect(curx, cury+dataY, bw, ratio*h);
          if (drawStripes) {
            float dw = (bw/binBasePairs);
            float curex = curx;
            int minoffset = minrt-minminrt;
            int maxoffset = maxmaxrt-maxrt;
            for (int k = 0;k<binBasePairs;k++) {
              if ((j*binBasePairs + k + minoffset) < vraw[i].length - maxoffset && (getV(i, j*binBasePairs + k +minoffset)>=eweight)) {
                if (j!=zoomBin) {
                  // fill(lerpColor(bottom,eventcolor,cer-sConf.getValuef()));
                  fill(getColor(1.0f, sum(praw[i][j*binBasePairs + k +minoffset])/4.0f, 1.0f));
                  rect(curex, cury+dataY, max(2, (dw)), ratio*h);
                }//end if
                events[j]++;
              }//end if
              curex+=dw;
            }//end for
          }//end if
        }//end if
        curx+=bw+cgap;
      }//end else
    }//end for  
    if (refRow == i) {
      fill(left40);
    }
    if (selectedRow!=-1 && i == reorder[selectedRow])
    {
      fill(left);
    }
    else {
      fill(coloroptions[rowcolors[i]]);
    }
    rect(-dataX, cury+dataY-ytrans, dataX, bh);
    fill(0);
    text(metadata[i], -(textWidth(metadata[i])/2.0f), cury+dataY-ytrans+(bh/2));
    cury+=bh+rgap;
    noStroke();
  }//end for
  if (zoomBin>=0) {
    stroke(0);
    strokeWeight(3);
    line( zoomS, dataY, zoomS, visibleCount*(bh+rgap)-rgap+dataY);
    line( zoomS+zoomW, dataY, zoomS+zoomW, visibleCount*(bh+rgap)-rgap+dataY);
    strokeWeight(2);
    fill(0, 0);
    if (rawcol>=0) {
      rect(zoomS + ((rawcol-(minrt-minminrt) - (zoomBin*binBasePairs))*(bpw+cgap)), dataY, bpw+cgap, visibleCount*(bh+rgap)-rgap);
    }
    else if (col>=0 && col<zoomBin) {
      rect(col*(bw+cgap), dataY, bw+cgap, visibleCount*(bh+rgap)-rgap);
    }
    else if (col>=0) {
      rect( ((col-(zoomBin+1))*(bw+cgap))+zoomS+zoomW, dataY, bw+cgap, visibleCount*(bh+rgap)-rgap);
    }
    noStroke();
  }
  else {
    if (col>=0 && mouseX <= winWidth - 2*wedgewidthonscreen) {
      stroke(0);
      strokeWeight(1);
      fill(0, 0);
      rect(col*(bw+cgap), 0+dataY, bw+cgap, visibleCount*(bh+rgap)-rgap);
      noStroke();
    }
  }
  popMatrix();

  if (drawStripes) {
    int maxe = max(events);
    for (int j = 0;j<vdisp[0].length;j++) {
      if (events[j]==0) {
        fill(bottom);
      }
      else {
        fill(lerpColor(bottom, eventcolor, .25f +(events[j]/PApplet.parseFloat(maxe))*.75f));
      }
      if (zoomBin==j) {
        strokeWeight(2);
      }//end if
      else {
        strokeWeight(1);
      }
      stroke(0);
      rect(dataX + j*oldbw, 15, oldbw, 10);
    }
    noStroke();
    fill(0);
  }
  else {
    float maxe = max(vhist);
    for (int j = 0;j<vdisp[0].length;j++) {
      if (vhist[j]==0) {
        fill(bottom);
      }
      else {
        fill(getColor(vhist[j], 0, maxe));
      }
      if (zoomBin==j) {
        strokeWeight(2);
      }//end if
      else {
        strokeWeight(1);
      }
      stroke(0);
      rect(dataX + j*oldbw, 15, oldbw, 10);
    }
    noStroke();
    fill(0);
  }
}//end drawEven


public int bpToIndex(char bp) {
  int index = -1;
  switch(bp) {
  case 'A':
  case 'a':
    index = 0;
    break;

  case 'T':
  case 't':
    index =  1;
    break;

  case 'C':
  case 'c':
    index =  2;
    break;

  case 'G':
  case 'g':
    index =  3;
    break;

  default:
    break;
  }//end switch
  return index;
}


public double getP(int i, int j) {
  if (i>=praw.length || j>=praw[i].length) {
    return -1;
  }
  double[] sample =  praw[i][j];

  double sum = 0;
  float pmask;
  int bp_i = bpToIndex(refgen[0][j]);
  boolean isSynom = true;
  int n  = 0;

  for (int k=0;k<sample.length;k++) {
    isSynom = bp_i>=0&&synom[j][bp_i][k];
    pmask = ( (nonsynomCheck.isSelected()&&isSynom) || (synomCheck.isSelected()&&!isSynom) )? 1: 0;
    // pmask = 1.0;
    if (pmask*sample[k]>0) {
      sum+= pmask*sample[k];
      n++;
    }
  }
  if (n==0) {
    return 0;
  }
  else {
    return (sum/n);
  }
}

public float getV(int i, int j) {
  if (i>=vraw.length || j>=vraw[i].length) {
    return -1;
  }
  float[] sample =  vraw[i][j];

  float sum = 0;
  float vmask;
  int bp_i = bpToIndex(refgen[refRow+1][j]);
  boolean isSynom = true;


  if (refRow==-1) {

    for (int k=0;k<sample.length;k++) {
      isSynom = bp_i>=0&&synom[j][bp_i][k];
      // vmask = ((synomCheck.isSelected())||isSynom)? 1: 0;
      vmask = ( (nonsynomCheck.isSelected()&&isSynom) || (synomCheck.isSelected()&&!isSynom) )? 1:0;
      // vmask = 1.0;
      sum+= vmask*sample[k];
    }
    return sum;
  }
  else {
    if (refgen[refRow+1][j]=='-' && covraw[i][j]!=0) {
      return 1.0f;
    }
    else if (bpToIndex(refgen[refRow+1][j])==-1)
      return 0.0f;
    return oneNormRef(toVector(sample, j), toVector(vraw[refRow][j], j), synom[j]);
  }//end else
}

public float[] toVector(float[] f, int index) {
  float[] f1 = new float[f.length];
  arrayCopy(f, f1);
  int bp_i = bpToIndex(refgen[0][index]);
  if (bp_i!=-1)
    f1[bp_i] = max(0, 1.0f-sum(f));
  return f1;
}
public float oneNormRef(float[] f, float[] g, boolean[][] synMask) {


  if (sum(f)==0) {
    return sum(g);
  }//end if
  else if (sum(g)==0) {
    return sum(f);
  }//end else if
  else if (synomCheck.isSelected()) {
    return oneNorm(f, g);
  }
  else {
    float bpsum = 0;
    float sum = 0;
    for (int i = 0;i<g.length;i++) {
      if (g[i]>0) {
        bpsum = 0;
        for (int j = 0;j<f.length;j++) {
          if (synMask[j][i]) {
            bpsum+= f[j];
          }
        }
        sum+= g[i]*bpsum;
      }//end if
    }//end for
    return sum;
  }//end else
}

public void calcReferenceGenome() {
  //refRow is the new reference sequence
  float a_ct = 0;//18
  float c_ct = 0;//19
  float g_ct = 0;//20
  float t_ct = 0;//21

  for (int r=0;r<vdisp.length;r++)
  {
    //refgen[r+1] = new char[cols];

    for (int c=0;c<vraw[r].length;c++)
    {
      if (bpToIndex(refgen[r+1][c])==-1) {
        a_ct = vraw[r][c][0];
        t_ct = vraw[r][c][1];
        c_ct = vraw[r][c][2];
        g_ct = vraw[r][c][3];

        if (sum(vraw[r][c])<=0.5f) {
          refgen[r+1][c] = refgen[0][c];
        }	
        else if (a_ct > c_ct && a_ct>g_ct && a_ct>t_ct) {
          refgen[r+1][c] = 'A';
        }
        else if (c_ct>a_ct && c_ct>g_ct && c_ct>t_ct) {
          refgen[r+1][c] = 'C';
        }
        else if (g_ct>a_ct && g_ct>c_ct && g_ct>t_ct) {
          refgen[r+1][c] = 'G';
        }
        else if (t_ct>a_ct && t_ct>c_ct && t_ct>g_ct) {
          refgen[r+1][c] = 'T';
        }
        else {
          refgen[r+1][c] = refgen[0][c];
        }
      }
    }
  }
}

public void drawTooltip() {
  // System.err.println("rawcol " + rawcol + "col " + col);
  if (row>=0 && row<rows && ( (col>=0 && col<cols && vdisp[row][col]>=0) || (rawcol>=0 && rawcol<=(maxrt-minrt) && getV(row, rawcol)>=0) ) ) {
    String label;
    float curvar = 0;

    if (vdisp[0].length==vraw[0].length) {
      curvar = vdisp[row][col]*100.0f;
      label = "ref_nt: "+(col+minrt)+" cov: "+covdisp[row][col]+"  var:"+curvar+"% p:"+pdisp[row][col] ;//+" actg_ct,n_ct,dip_ct: "+ldisp[row][col][0]+","+ldisp[row][col][1]+","+ldisp[row][col][2];
    }//end if
    else if (rawcol>=0 && rawcol<=(maxrt-minrt)) {
      curvar = getV(row, rawcol)*100.0f;
      label = "ref_nt: "+(rawcol+minrt)+" cov: "+covraw[row][rawcol]+"  var:"+curvar+"% p:"+getP(row, rawcol);//+" actg_ct,n_ct,dip_ct: "+lraw[row][rawcol][0]+","+lraw[row][rawcol][1]+","+lraw[row][rawcol][2];
    }
    else {
      curvar = vdisp[row][col]*100.0f;
      int refmin = floor(col*(binBasePairs)) + minrt;
      int refmax = min(maxrt, refmin+binBasePairs-1);
      label = "ref_nts: "+refmin+"-"+refmax+" cov: "+covdisp[row][col]+"  var:"+curvar+"% p:"+pdisp[row][col];//+" actg_ct,n_ct,dip_ct: "+ldisp[row][col][0]+","+ldisp[row][col][1]+","+ldisp[row][col][2];
    }//end else
    float offset = 0;
    if (mouseX-2-xtrans+textWidth(label)+4 > winWidth) {
      offset = textWidth(label)+4;
    }//end if
    fill(tipcolor);
    // rect(mouseX-2-xtrans-offset,max(0-ytrans,mouseY-12-ytrans),textWidth(label)+4,18);
    rect(mouseX-2-xtrans-offset, max(0-ytrans, mouseY-12-ytrans), textWidth(label)+4, 18);
    fill(0);
    text(label, mouseX-xtrans-offset+(textWidth(label)/2.0f), max(12-ytrans, mouseY-ytrans));
  }//end if
}//end drawTooltip

public void drawORF() {
  pushMatrix();
  translate(dataX, 25);
  int[] curORF;
  float sx;
  float ex;
  int maxDepth = max(depths);
  for (int i = 0;i<starts.length;i++) {
    sx = map(starts[i], minrt, maxrt, 0, dataWidth);
    ex = map(ends[i], minrt, maxrt, 0, dataWidth);
    pushMatrix();
    translate(sx, floor(depths[i]*((50)/PApplet.parseFloat(maxDepth+1))));
    drawArrow(ex-sx, floor((50)/PApplet.parseFloat(maxDepth+1)));
    fill(0);
    text(orfNames[i], 1+textWidth(orfNames[i])/2.0f, floor(50/PApplet.parseFloat(maxDepth+1)-8));
    //System.err.println("Draw ORF["+i+"]: "+starts[i]+"-"+ends[i]+" is at depth "+depths[i]);
    popMatrix();
  }
  popMatrix();

  //draw histogram lines
}




public void drawArrow(float w, float h) {
  float headw = floor(min(10, w/5.0f));
  float headh = floor(h/5.0f);
  noStroke();
  fill(0);
  rect(0, floor(headh), ceil(w-headw), floor(h-2*headh));
  triangle(floor(w-headw), ceil(h), floor(w-headw), 0, w, ceil(h/2.0f));
  fill(255);
  rect(1, floor(headh)+1, ceil(w-headw), floor(h-2*headh)-2);
  triangle(floor(w-headw)+1, ceil(h)-1, floor(w-headw)+1, 2, ceil(w-2), ceil(h/2.0f));
}


public void resetForBin()
{
  int range = maxrt-minrt;
  numBins = ceil(range/binBasePairs);
  bw = (dataWidth/PApplet.parseFloat(numBins));
  if (bw>=1) {
    sample(binBasePairs);
    //println(bw + "--" + binBasePairs);
  }
  else {
    sample(minBasePairs);
    binBasePairs = minBasePairs;
    bw = (dataWidth/PApplet.parseFloat((range/minBasePairs)));
    //println(bw + "--" + minBasePairs);
  }
  prevBinVal = binBasePairs;
  oldbw = bw;      
  //sConf.setLimits(maxn*50,0,max(25,maxn));     
  //tConf.setText(str(maxn*50));
  //sVar.setLimits(maxvariant*.4,0,maxvariant);
  //tVar.setText(str(maxvariant*.4));



  //perV1.changeLabel( str(maxvariant*2), 120,40);
  //perV1 = new GLabel(this,str(maxvariant*2), winWidth - 35, 70, 120);
  //println("Variant threshold changed to " + maxvariant);
}

//------------------------------------------------------------------
////////////////////        FEEDBACK            ////////////////////
//------------------------------------------------------------------
public void handleSliderEvents(GSlider slider) {
  if (slider == sBin) {
    //println(binBasePairs);
    binBasePairs = sBin.getValue();
    //tBin.setText(str(binBasePairs));
    resetForBin();
  }

  else if (slider == sConf) {
    //println("Ncount threshold changed to " +sNcount.getValuef());
    tConf.setText(str(sConf.getValuef()));
  }
  // else if(slider == sVar){
  // vweight= sVar.getValuef();
  //  tVar.setText(sVar.getValuef()+"");
  //wedge.right = vweight/(maxvariant);
  // if(wedge.left>=wedge.right)
  //    wedge.left=wedge.right;
  //println("Variant threshold changed to " +sVar.getValuef());
  // }
  else if (slider == sEvent) {
    eweight= sEvent.getValuef();
    tEvent.setText(str(eweight));     
    //println("Event variant threshold changed to " + sEvent.getValuef());
  }
}

public void handleButtonEvents(GButton button) {
  if (button == btnOpen) 
    switch(button.eventType) {
    case GButton.CLICKED:
      String openPath = selectInput();  // Opens file chooser
      if (openPath == null) {
        // If a file was not selected
        println("No input file was selected...");
      } 
      else {
        // If a file was selected, print path to folder
        println(openPath);
        String lines[] = loadStrings(openPath);
        if (lines.length!=5)
          println("File input not recognized");
        for (int i=0; i < lines.length; i++) {
          //println(lines[i]);
        }
        binBasePairs = PApplet.parseInt(lines[0]);
        vweight = PApplet.parseFloat(lines[1]);
        eweight = PApplet.parseFloat(lines[2]);
        maxvariant = PApplet.parseFloat(lines[5]);
        int numrows = PApplet.parseInt(lines[10]);
        visibleCount = PApplet.parseInt(lines[8]);
        bh = PApplet.parseFloat(lines[9]);
        //set ordering
        if (numrows != vdisp.length)
        {
          println("***Error in importing Settings!**");
          println("   Number of Sequences do not match");
        } 
        else
        {
        }
        //set sliders
        //sBin.setLimits(binBasePairs, minBasePairs, 160);
        //sVar.setLimits(vweight,0,maxvariant);
        wedge.right = (vweight);
        if (wedge.left>=wedge.right)
          wedge.left=wedge.right; 
        sEvent.setLimits(eweight, 0, maxvariant);
        tEvent.setText(str(eweight));

        //tBin.setText(str(eweight));
      }
      break;
    default:
      System.err.println("Unknown mouse event");
    }
  if (button == btnSave) 
    switch(button.eventType) {
    case GButton.CLICKED:
      String savePath = selectOutput();  // Opens file chooser
      if (savePath == null) {
        // If a file was not selected
        println("No output file was selected...");
      } 
      else {
        // If a file was selected, print path to folder
        println(savePath);
        String names = binBasePairs + " " + vweight + " " + eweight + " " 
          + maxvariant+ " " 
          + " " + visibleCount + " " + bh;
        names +=  " " + str(vdisp.length);
        String[] list = split(names, ' ');
        //String[] list2 = split(order, ' ');
        saveStrings(savePath, list);
        //saveStrings(savePath, list2);
      }

      break;
    default:
      System.err.println("Unknown mouse event");
    }
}

public void handleCheckboxEvents(GCheckbox cbox) {
  if (cbox == stripeCheck) {
    if (stripeCheck.isSelected())
      mode = 2;
    else
      mode = 0;
  }
  else if (cbox == synomCheck || cbox == nonsynomCheck) {
    //   if(synomCheck.isSelected())
    //     ratio = 2;
    //   else
    //     ratio = 10;
    resetForBin();
  }
}

public void handleOptionEvents(GOption selected, GOption deselected) {
  //select new reference - newRefRow holds this
  refRow = -1;
  //non-synom check
  if (selected == reference[0]) {
    refRow = -1;
    resetForBin();
  }
  else {
    for (int i = 1;i<reference.length;i++) {
      if (selected == reference[i])
      {
        refRow = reorder[i-1];
        resetForBin();
      }
    }
  }
}

public void switchmode(int value) {
  switchvar++;
  if (switchvar%2==0)
    mode = 0;
  else
    mode = 2;

  switchvar %=10;
}

//------------------------------------------------------------------
////////////////////        TEXTBOX            ////////////////////
//------------------------------------------------------------------
public void handleTextFieldEvents(GTextField tfield) {

  //ncount
  if (tfield == tConf) {
    switch (tfield.getEventType()) {
    case GTextField.CHANGED:
      break;
    case GTextField.ENTERED:
      if (PApplet.parseFloat(tConf.viewText()) < -70) {
        tConf.setText(str(-70));
      }
      else if (PApplet.parseFloat(tConf.viewText()) > -1) {
        tConf.setText(str(-1));
      }
      sConf.setValue(PApplet.parseFloat(tConf.viewText()));
      break;
    }
  }     
  //dipcount

  //event
  if (tfield == tEvent) {
    switch (tfield.getEventType()) {
    case GTextField.CHANGED:
      break;
    case GTextField.ENTERED:
      if (PApplet.parseFloat(tEvent.viewText()) > 1.0f) {
        eweight = 1.0f;
        tEvent.setText(str(eweight));
      }
      else if (PApplet.parseFloat(tEvent.viewText()) < 0) {
        eweight = 0;
        tEvent.setText(str(0));
      }
      else
        eweight = PApplet.parseFloat(tEvent.viewText());
      sEvent.setLimits(eweight, 0, 1.0f);
      break;
    }
  }

  //variant
  /*  if(tfield == tVar){
   switch (tfield.getEventType()){
   case GTextField.CHANGED:
   break;
   case GTextField.ENTERED:
   if(float(tVar.viewText()) > maxvariant){
   // vweight = maxvariant;
   tConf.setText(str(vweight));
   }
   else if (float(tVar.viewText()) < 0){
   //  vweight = 0;
   tVar.setText(str(0));
   }
   // else
   //   vweight = float(tVar.viewText());
   //sVar.setLimits(vweight,0,maxvariant);
   
   wedge.right = vweight;
   if(wedge.left>=wedge.right)
   wedge.left=wedge.right;
   break;
   
   }
   }
   */
  //data limit
  if (tfield==tstart && tfield.getEventType()==GTextField.ENTERED) {
    int newmin = PApplet.parseInt(tstart.viewText());
    if (newmin>=minminrt && newmin<maxrt) {
      minrt = newmin;
      resetForBin();
    }
    else if (newmin<=minminrt) {
      tstart.setText(str(minminrt));
      resetForBin();
    }
    else {
      tstart.setText(str(minrt));
      resetForBin();
    }
  }  

  if (tfield==tend && tfield.getEventType()==GTextField.ENTERED) {
    int newmax = PApplet.parseInt(tend.viewText());
    if (newmax<=maxmaxrt && newmax>minrt) {
      maxrt = newmax;
      resetForBin();
    }
    else if (newmax>=maxmaxrt) {
      tend.setText(str(maxmaxrt));
      resetForBin();
    }
    else {
      tend.setText(str(maxrt));
      resetForBin();
    }
  }
}

public void keyPressed() {
  //pressed = true;
}
public void keyReleased() {
  pressed = false; 
  //prevRow = -1;
  //currRow = -1;
}

//------------------------------------------------------------------
////////////////////        MOUSE            ////////////////////
//------------------------------------------------------------------
public void mousePressed() {
  oldx = mouseX;
  oldy = mouseY;
  if (mouseButton==RIGHT && oldx>=dataX && oldy<winHeight - 160 && oldy>dataY && oldx<=dataX+dataWidth+bw) {
    if (zoomBin==-1 || rawcol==-1) {
      zoomBin = col;
    }
    else if (rawcol>=-1) {
      zoomBin = -1;
      bw = oldbw;
    }
  }
  if (oldy<(winHeight - 160) && oldy>dataY && oldx<dataX) { // && oldx<dataX+ dataWidth){
    if (mouseButton==RIGHT) {
      int changeRow =   reorder[PApplet.parseInt((oldy - dataY)/(bh + rgap))];
      // selectedRow = reorder[int((oldy - dataY)/(bh + rgap))];
      // rowcolors[selectedRow] = (rowcolors[selectedRow]+1) % (coloroptions.length);
      rowcolors[changeRow] = (rowcolors[changeRow]+1) % (coloroptions.length);
      // println(" row = " + selectedRow);
    }
    else {
      selectedRow = PApplet.parseInt((oldy - dataY)/(bh + rgap));
      pressed = true;
    }
  }
  if (mouseButton==LEFT && zoomBin>=0 && oldy<(winHeight - 160) && oldy>dataY && oldx>dataX + zoomS && oldx<dataX + zoomS + zoomW) { // && oldx<dataX+ dataWidth){
    pressed = true;

    //wedge.draw();
  }

  if (mouseButton==LEFT && oldy>=(winHeight - 160) && oldx<30 + wedgewidthonscreen*2) {
    wedge.mousePressedAlt(oldx, oldy);
    //wedge.draw();
  }
}//end mousePressed

public void mouseClicked() {
}//end mouseClicked

public void mouseReleased() {
  pressed = false;
  selectedRow = -1;
  wedge.mouseReleasedAlt();
}

public void mouseDragged() {
  if (mouseButton==LEFT && pressed == true && mouseY<(winHeight - 160) && mouseY>dataY && mouseX<dataX)
  {
    draggedRow = PApplet.parseInt((mouseY - dataY)/(bh + rgap));

    if (selectedRow!=draggedRow)
    {
      switchrows(selectedRow, draggedRow);
      selectedRow = draggedRow;
    }
  }

  if (mouseButton==LEFT && oldy>(winHeight - 160) && oldx<30 + wedgewidthonscreen*2) {
    wedge.mouseDraggedAlt(mouseX, mouseY);
    wedge.draw();
    //update slider values for varint - perfect
    vweight = wedge.right;
    //sVar.setLimits(maxvariant*wedge.right,0,maxvariant);
    // tVar.setText(str(maxvariant*wedge.right));
  }

  if (mouseButton==RIGHT && oldy<winHeight - 160 && oldy>dataY && mouseX>=dataX && mouseX<=dataX+dataWidth) {
    if (zoomBin==-1 || rawcol==-1) {
      zoomBin = col;
    }
  }
  if (oldy<winHeight - 75 && oldx<=winWidth - wedgewidthonscreen*2) {
    //xtrans-=oldx-mouseX;
    //ytrans-=oldy-mouseY;
    oldx = mouseX;
    oldy = mouseY;
  }
}//end mouseDragged


//------------------------------------------------------------------
////////////////////        LOAD            ////////////////////
//------------------------------------------------------------------


public void loadTest() {
  //need to set:  
  //  vraw
  //  lraw
  //  rows
  //  cols 
  //  genome = new char[cols];
  //  refgen = new char[rows+1][cols];
  //  metadata = new String[rows];
  //  rowcolors = new int[rows];
  //  synom = new boolean[rows][rows][cols];
  //  

  maxmaxrt = 0;
  minminrt = 999999;
  maxrt = 0;
  minrt = 999999;

  //System.err.println(dir);

  checkRows(dataPath("Virus Data/SNP.csv"));
  checkMaxMin(dataPath("Virus Data/SNP.csv"));
  maxmaxrt++;
  cols = maxmaxrt - minminrt;
  //System.err.println("max "+maxmaxrt+" min "+minminrt + " rows"+rows+" cols"+cols);   

  vraw = new float[rows][cols][4]; // a_%,t_%,c_5,g_% 
  praw = new double[rows][cols][4]; // a_p, t_p, c_p, g_p
  covraw = new int[rows][cols];
  refgen = new char[rows+1][cols];   
  rowcolors = new int[rows];
  synom = new boolean[cols][4][4];
  for (int i = 0;i<refgen.length;i++) {
    for (int j= 0;j<refgen[i].length;j++) {
      refgen[i][j] = 'N';
      for (int k = 0;k<4;k++) {
        synom[j][k] = new boolean[] {
          false, false, false, false
        };
      }
    }
  } 

  calcSynom(dataPath("Virus Data/Consensus.gbk"));
  //System.err.println("calculated synon.");
  loadAll(dataPath("Virus Data/SNP.csv"));
  //System.err.println("loaded data.");
  loadFasta(dataPath("Virus Data/References.fasta"));
  // System.err.println("calculated refs.");
}//end loadTest


public void loadDir(String dir) {
  //need to set:  
  //  vraw
  //  lraw
  //  rows
  //  cols 
  //  genome = new char[cols];
  //  refgen = new char[rows+1][cols];
  //  metadata = new String[rows];
  //  rowcolors = new int[rows];
  //  synom = new boolean[rows][rows][cols];
  //  

  maxmaxrt = 0;
  minminrt = 999999;
  maxrt = 0;
  minrt = 999999;

  //System.err.println(dir);
  File[] files = new File(dir).listFiles();
  rows = files.length;

  for (int i = 0;i<files.length;i++) {
    checkMaxMin(files[i].getPath());
    //System.err.println("max "+maxmaxrt+" min "+minminrt);
  }//end for
  maxmaxrt++;
  cols = maxmaxrt - minminrt;


  vraw = new float[rows][cols][4]; // a_%,t_%,c_5,g_% 
  praw = new double[rows][cols][4]; // a_p, t_p, c_p, g_p
  covraw = new int[rows][cols];
  refgen = new char[rows+1][cols];   
  metadata = new String[rows];
  rowcolors = new int[rows];
  synom = new boolean[cols][4][4];
  for (int i = 0;i<refgen.length;i++) {
    for (int j= 0;j<refgen[i].length;j++) {
      refgen[i][j] = 'N';
      for (int k = 0;k<4;k++) {
        synom[j][k] = new boolean[] {
          false, false, false, false
        };
      }
    }
  } 

  String reffname = selectInput("Select a .csv or .gbk reference file");
  if (reffname==null) {
    reffname = dataPath("Test.gbk");
  }
  calcSynom(reffname);

  for (int i = 0;i<files.length;i++) {
    metadata[i] = files[i].getName().substring(0, files[i].getName().lastIndexOf('.'));
    loadOne(files[i].getPath(), i);
  }//end for
  loadFasta(dataPath("Test.fasta"));
}//end loadDir

public void loadFasta(String filename) {
  String[] lines = loadStrings(filename);
  String seqname;
  char[] sequence;
  int curRow = -1;
  int index = -1;
  int curDex;
  //System.err.println(lines.length);
  for (String line:lines) {
    if (line.charAt(0)=='>') {
      seqname = line.substring(1);
      //  System.err.println(seqname);
      curRow = search(metadata, seqname);
      if (curRow==-1) {
        //  System.err.println("Can't find "+seqname);
      }
      index = 0;
    }//end if
    else if (curRow!=-1) {
      sequence = line.toCharArray();
      for (int i = 0;i<sequence.length;i++) {
        curDex = index+i+1;
        if (curDex>=minminrt && curDex<maxmaxrt) {
          refgen[curRow+1][curDex-minminrt]=sequence[i];
          if (sequence[i]=='-') {
            // System.err.println(curRow+" "+curDex);
          }
        }
      }
      index+=sequence.length;
    }

    //System.err.println(line);
  }
}//end loadFasta

public int search(String[] strings, String val) {
  for (int i = 0;i<strings.length;i++) {
    if (strings[i].equals(val))
      return i;
  }
  return -1;
}


public void checkRows(String filename) {
  int name_col = -1;
  HashMap names = new HashMap();
  String[] lines = loadStrings(filename);
  String[] header = lines[0].split(",");
  String c_name;
  for (int i = 0;i<header.length;i++) {
    c_name = trim(header[i]);
    if (c_name.equals("Sequence Name")) {
      name_col = i;
    }
  }

  if (name_col==-1) {
    System.err.println(filename);
  }  
  String[] aline;
  int index = 0;
  for (int i = 1;i<lines.length;i++) {
    aline = (lines[i].replaceAll("(\")(\\d+)(,)(\\d+)(\")", "$2$4")).split(",");
    if (!aline[name_col].equals("Consensus") && !names.containsValue(aline[name_col])) {
      names.put(index+"", aline[name_col]);
      index++;
      // System.err.println(aline[name_col]);
    }
  }
  metadata = new String[names.size()];
  for (int i = 0;i<metadata.length;i++) {
    metadata[i] = names.get((i+"")).toString();
  }
  rows = metadata.length;
}

public void checkMaxMin(String filename) {
  int id_col = -1;
  String[] lines = loadStrings(filename);
  String[] header = lines[0].split(",");
  String c_name;
  for (int i = 0;i<header.length;i++) {
    c_name = trim(header[i]);
    //      if(c_name.equals("Nucleotide") || c_name.equals("Min (original sequence)") || c_name.equals("Minimum")){
    if (c_name.equals("Min (with gaps)")) {
      id_col = i;
    }
  }

  if (id_col==-1) {
    System.err.println(filename);
  }  
  String[] aline;
  int rt = 0;
  for (int i = 1;i<lines.length;i++) {
    aline = (lines[i].replaceAll("(\")(\\d+)(,)(\\d+)(\")", "$2$4")).split(",");
    if (aline.length>id_col) {
      rt = PApplet.parseInt(aline[id_col]);
      if (rt<minminrt) {
        minminrt = rt;
        minrt = rt;
      }
      if (rt>maxmaxrt) {
        maxmaxrt = rt;
        maxrt = rt;
      }
    }
  }
}

public boolean loadOne(String filename, int index) {
  // System.err.println("Loading "+filename);
  String[] lines = loadStrings(filename);
  String[] header = lines[0].split(",");

  int id_col = -1;
  int ref_col = -1;
  int varbp_col = -1;
  int var_col = -1;
  int ct_col = -1;
  int p_col = -1;
  int syn_col = -1;
  int change_col = -1;
  int poly_col = -1;
  String c_name;
  for (int i = 0;i<header.length;i++) {
    c_name = trim(header[i]);
    // if(c_name.equals("Nucleotide") || c_name.equals("Min (with gaps)") || c_name.equals("Minimum")){
    if (c_name.equals("Min (with gaps)")) {
      id_col = i;
      // System.err.println("Found id col: "+i);
    }//end if
    else if (c_name.equals("Change")) {
      change_col = i;
    }
    else if (c_name.equals("Reference Nucleotide(s)")) {
      ref_col = i;
      // System.err.println("Found ref col: "+i);
    }
    else if (c_name.equals("Polymorphism Type")) {
      poly_col = i;
    }
    else if (c_name.equals("Variant Nucleotide(s)")) {
      varbp_col = i;
      //System.err.println("Found v_n col: "+i);
    }
    else if (c_name.equals("Variant Frequency")) {
      var_col = i;
      // System.err.println("Found v% col: "+i);
    }
    else if (c_name.equals("Coverage")) {
      ct_col = i;
      // System.err.println("Found c# col: "+i);
    }
    else if (c_name.equals("Variant P-Value (approximate)") || c_name.equals("Strand-Bias >50% P-value")) {
      p_col = i;
      // System.err.println("Found p col: "+i);
    }
    else if (c_name.equals("Amino Acid Change")) {
      syn_col = i;
    }
  }//end for

  for (int i = 0;i<vraw[index].length;i++) {
    vraw[index][i] = new float[] {
      0, 0, 0, 0
    };
    praw[index][i] = new double[] {
      0, 0, 0, 0
    };
    covraw[index][i] = 0;
  }//end for

  int c;
  int bp_i = -1;
  String col_id;
  String[] change;
  String[] aline;
  String type;
  for (int i = 1;i<lines.length;i++) {
    aline = (lines[i].replaceAll("(\")(\\d+)(,)(\\d+)(\")", "$2$4")).split(",");
    if (poly_col!=-1 && aline.length>=poly_col)
      type = aline[poly_col];
    else
      type = "";

    if (poly_col==-1 || (!(aline[1].equals("CDS")) && (type.equals("SNP (transition)") || type.equals("SNP (transversion)") || type.equals("Substitution") ))) {
      //System.err.println(lines[i]);
      //System.err.println(lines[i].replaceAll("(\")(\\d+)(,)(\\d+)(\")","$2$4"));
      c = PApplet.parseInt(aline[id_col])-minminrt;

      bp_i = -1; 
      if (ref_col==-1 && change_col!=-1) {
        // System.err.println(lines[i]);
        //  System.err.println(filename+"Line "+i+". c="+aline[id_col]+"-"+minminrt+" = "+c+ " , type = "+type+ " p value =" + Double.parseDouble(aline[p_col]));

        change = (trim(aline[change_col])).split(" ->");
        if (change.length==2) {
          refgen[index+1][c] = trim(change[0]).charAt(0);
          bp_i = bpToIndex(trim(change[1]).charAt(0));
        }
      }
      else {
        //System.err.println(filename+"Line "+i+". c="+aline[id_col]+"-"+minminrt+" = "+c+ " , type = "+type+ " p value =");
        refgen[index+1][c] = trim(aline[ref_col]).charAt(0);
        bp_i = bpToIndex(trim(aline[varbp_col]).charAt(0));
      }

      vraw[index][c][bp_i] = toFloatPercent(aline[var_col]);
      praw[index][c][bp_i] = Double.parseDouble(aline[p_col]);//(new BigDecimal(aline[p_col])).doubleValue();
      if (ct_col!=-1) {
        covraw[index][c] = PApplet.parseInt(aline[ct_col]);
        if (covraw[index][c]>maxcovraw) {
          maxcovraw = covraw[index][c];
          // System.err.println("raw: " + maxcovraw);
        }
      }
      if (aline.length>syn_col) {
        if (bpToIndex(refgen[0][c])!=-1) {
          synom[c][bpToIndex(refgen[0][c])][bp_i] = trim(aline[syn_col]).length()>0;
        }
        else {
          change = (trim(aline[change_col])).split(" ->");
          synom[c][bpToIndex(trim(change[0]).charAt(0))][bp_i] = trim(aline[syn_col]).length()>0;
        }
      }
    }
    else {
      //System.err.println(lines[i]);
    }
  }//end for

  return true;
}//end loadOne

public boolean loadAll(String filename) {
  // System.err.println("Loading "+filename);
  String[] lines = loadStrings(filename);
  String[] header = lines[0].split(",");

  int name_col = -1;
  int id_col = -1;
  int ref_col = -1;
  int varbp_col = -1;
  int var_col = -1;
  int ct_col = -1;
  int p_col = -1;
  int syn_col = -1;
  int change_col = -1;
  int poly_col = -1;
  String c_name;
  for (int i = 0;i<header.length;i++) {
    c_name = trim(header[i]);
    // if(c_name.equals("Nucleotide") || c_name.equals("Min (with gaps)") || c_name.equals("Minimum")){
    if (c_name.equals("Sequence Name")) {
      name_col = i;
    }
    else if (c_name.equals("Min (with gaps)")) {
      id_col = i;
      // System.err.println("Found id col: "+i);
    }//end if
    else if (c_name.equals("Change")) {
      change_col = i;
    }
    else if (c_name.equals("Reference Nucleotide(s)")) {
      ref_col = i;
      // System.err.println("Found ref col: "+i);
    }
    else if (c_name.equals("Polymorphism Type")) {
      poly_col = i;
    }
    else if (c_name.equals("Variant Nucleotide(s)")) {
      varbp_col = i;
      //System.err.println("Found v_n col: "+i);
    }
    else if (c_name.equals("Variant Frequency")) {
      var_col = i;
      // System.err.println("Found v% col: "+i);
    }
    else if (c_name.equals("Coverage")) {
      ct_col = i;
      // System.err.println("Found c# col: "+i);
    }
    else if (c_name.equals("Variant P-Value (approximate)") || c_name.equals("Strand-Bias >50% P-value")) {
      p_col = i;
      // System.err.println("Found p col: "+i);
    }
    else if (c_name.equals("Amino Acid Change")) {
      syn_col = i;
    }
  }//end for

  for (int i = 0;i<vraw.length;i++) {
    for (int j = 0;j<vraw[i].length;j++) {
      vraw[i][j] = new float[] {
        0, 0, 0, 0
      };
      praw[i][j] = new double[] {
        0, 0, 0, 0
      };
      covraw[i][j] = 0;
    }//end for
  }

  int index = -1;
  int c;
  int bp_i = -1;
  String col_id;
  String[] change;
  String[] aline;
  String type;
  for (int i = 1;i<lines.length;i++) {

    aline = (lines[i].replaceAll("(\")(\\d+)(,)(\\d+)(\")", "$2$4")).split(",");
    if (poly_col!=-1 && aline.length>=poly_col)
      type = aline[poly_col];
    else
      type = "";

    index = search(metadata, aline[name_col]);
    if ((!aline[name_col].equals("Consensus")) && (poly_col==-1 || (!(aline[1].equals("CDS")) && (type.equals("SNP (transition)") || type.equals("SNP (transversion)") || type.equals("Substitution") )))) {
      //System.err.println(lines[i]);
      //System.err.println(lines[i].replaceAll("(\")(\\d+)(,)(\\d+)(\")","$2$4"));
      c = PApplet.parseInt(aline[id_col])-minminrt;

      bp_i = -1; 
      if (ref_col==-1 && change_col!=-1) {
        // System.err.println(lines[i]);
        //  System.err.println(filename+"Line "+i+". c="+aline[id_col]+"-"+minminrt+" = "+c+ " , type = "+type+ " p value =" + Double.parseDouble(aline[p_col]));

        change = (trim(aline[change_col])).split(" ->");
        if (change.length==2) {
          refgen[index+1][c] = trim(change[0]).charAt(0);
          bp_i = bpToIndex(trim(change[1]).charAt(0));
        }
      }
      else {
        //System.err.println(filename+"Line "+i+". c="+aline[id_col]+"-"+minminrt+" = "+c+ " , type = "+type+ " p value =");
        refgen[index+1][c] = trim(aline[ref_col]).charAt(0);
        bp_i = bpToIndex(trim(aline[varbp_col]).charAt(0));
      }

      vraw[index][c][bp_i] = toFloatPercent(aline[var_col]);
      praw[index][c][bp_i] = Double.parseDouble(aline[p_col]);//(new BigDecimal(aline[p_col])).doubleValue();
      if (ct_col!=-1) {
        covraw[index][c] = PApplet.parseInt(aline[ct_col]);
        if (covraw[index][c]>maxcovraw) {
          maxcovraw = covraw[index][c];
          // System.err.println("raw: " + maxcovraw);
        }
      }
      if (aline.length>syn_col) {
        if (bpToIndex(refgen[0][c])!=-1) {
          synom[c][bpToIndex(refgen[0][c])][bp_i] = trim(aline[syn_col]).length()>0;
        }
        else {
          change = (trim(aline[change_col])).split(" ->");
          synom[c][bpToIndex(trim(change[0]).charAt(0))][bp_i] = trim(aline[syn_col]).length()>0;
        }
      }
    }
    else {
      //System.err.println(lines[i]);
    }
  }//end for

  return true;
}//end loadAll

public float toFloatPercent(String percent) {
  String pf = percent.replaceAll("%", "");
  if (Float.isNaN(PApplet.parseFloat(pf)/100.0f)) {
    pf = trim(percent).substring(0, percent.indexOf("%"));
    //System.err.println("%: "+pf);
    return 0;
  }
  return PApplet.parseFloat(pf)/100.0f;
}//end toFloatPercent

public String toPercentFloat(float value) {
  int rounded = round( value*1000);
  float newVal = rounded / 10;
  return newVal+"%";
}

public void calcSynom(String filename) {
  setupcodontable();
  String ext = filename.substring(filename.lastIndexOf('.')+1);
  // System.err.println(ext);
  String[] lines = loadStrings(filename);
  String[] aline;
  String[]pairs;
  String[] pair;
  int[] depthEnds = new int[] {
    minminrt
  };



  if (ext.equals("csv")) {
    starts = new int[lines.length];
    ends = new int[lines.length];
    depths = new int[lines.length];
    orfNames = new String[lines.length];  
    for (int i = 0;i<lines.length;i++) {
      aline = lines[i].split(",");
      pairs = aline[0].split(";");

      for (int j = 0;j<pairs.length;j++) {
        pair = pairs[j].split("-");
        starts[i] = PApplet.parseInt(pair[0]);
        if (starts[1]<minminrt) {
          //   minminrt = starts[1];
        }
        ends[i] = PApplet.parseInt(pair[1]);
        if (ends[i]>maxmaxrt) {
          //   maxmaxrt = ends[i];
        }
        orfNames[i] = "ORF"+i;
      }
    }
  }
  else if (ext.equals("gbk")) {
    int numORFs = 0;
    for (int i = 0;i<lines.length;i++) {
      if (trim(lines[i]).length()>=3 && trim(lines[i]).substring(0, 3).equals("ORF")) {
        numORFs++;
      }//end if
      else {
      }
    }//end for
    starts = new int[numORFs];
    ends = new int[numORFs];
    depths = new int[numORFs];
    orfNames = new String[numORFs];
    numORFs = 0;
    for (int i = 0;i<lines.length;i++) {
      if (trim(lines[i]).length()>=3 && trim(lines[i]).substring(0, 3).equals("ORF")) {
        pairs = ((trim(lines[i])).substring(3)).split("\\.\\.");
        starts[numORFs] = PApplet.parseInt(trim(pairs[0]));
        if (starts[numORFs]<minminrt) {
          //  minminrt = starts[numORFs];
        }
        ends[numORFs] = PApplet.parseInt(trim(pairs[1]));
        if (ends[numORFs]>maxmaxrt) {
          //   maxmaxrt = ends[numORFs];
        }
        numORFs++;
      }//end if
      else if (trim(lines[i]).length()>=6 && trim(lines[i]).substring(0, 6).equals("/label")) {
        // System.err.println(lines[i]);
        // System.err.println(trim(lines[i]).split("=")[1]);
        orfNames[numORFs-1] = trim(lines[i]).split("=")[1];
      }
      else if (match(trim(lines[i]), "\\d+ [A-Z]+|[A-Z]+")!=null) {
        String[] temprefs = trim(lines[i]).split(" +");
        int startref = PApplet.parseInt(temprefs[0]);  
        for (int j=1;j<temprefs.length;j++) {
          for (int k=0;k<temprefs[j].length();k++) {
            if (startref+k>=minminrt && startref+k<maxmaxrt) {
              refgen[0][startref+k -minminrt] = temprefs[j].charAt(k);
            }
          }
          startref+=temprefs[j].length();
        }
      }
    }//end for
  }//end else if

  for (int i = 0;i<starts.length;i++) {
    if (i==0) {
      depths[i] = 0;
      depthEnds[0] = ends[i];
    }
    else {
      int k = 0;
      while (k<depthEnds.length && depthEnds[k]>starts[i]) {
        k++;
      }
      if (k>=depthEnds.length || depthEnds[k]>starts[i]) {
        int[] depthEndstemp = new int[depthEnds.length+1];
        for (int l=0;l<depthEnds.length;l++) {
          depthEndstemp[l] = depthEnds[l];
        }
        depthEndstemp[depthEndstemp.length-1] = ends[i];
        depths[i] = depthEndstemp.length-1;
        depthEnds = depthEndstemp;
      }
      else {
        depths[i] = k;
        depthEnds[k] = ends[i];
      }
    }
    //System.err.println("ORF["+i+"]: "+starts[i]+"-"+ends[i]+" is at depth "+depths[i]);
  }//end for
  setSynomRange();
}




public void setSynomRange() {
  //System.err.println("Coding section of genome goes from "+minminrt+" - "+maxmaxrt);

  int start;
  int end;
  int j;
  boolean missing;
  String curCodon = "";
  int offset = 0;
  for (int i = 0;i<starts.length;i++) {
    start = starts[i]+offset;
    end = ends[i];
    offset = 0;
    for (j = start;j<end;j+=3) {
      curCodon = "";
      for (int k=0;k<3;k++) {
        if (j+k<end && j+k<maxmaxrt) {
          curCodon =curCodon + refgen[0][j+k-minminrt];
        }
      }
      if (curCodon.length()==3) {
        setSynomCodon(curCodon, new int[] {
          j, j+1, j+2
        }
        );
      }
      else if (curCodon.length()==2) {
        offset =1;
        curCodon=curCodon+refgen[0][starts[i]+1-minminrt];
        setSynomCodon(curCodon, new int[] {
          j, j+1, starts[i]+1
        }
        );
        // System.err.println("Fixed 1 gap");
      }
      else if (curCodon.length()==1) {
        offset =2;
        curCodon=curCodon+refgen[0][starts[i]+1-minminrt]+refgen[0][starts[i]+2-minminrt];
        // System.err.println("Fixed 2 gap");
        setSynomCodon(curCodon, new int[] {
          j, starts[i]+1, starts[i]+2
        }
        );
      }
      else {
        // System.err.println("Trouble! '"+curCodon+"'");
      }
    }//end for
  }//end for
}



public void setSynomCodon(String codon, int[] indices) {
  if (codon.length()!=3) {
    System.err.println("Trouble: "+codon);
  }
  char[] aCodon;
  char[] bCodon; 
  for (int i = 0;i<indices.length;i++) {
    for (int j = 0;j<4;j++) { 
      aCodon = codon.toCharArray();
      aCodon[i] = atcgOrder[j];
      for (int k = 0;k<4;k++) {
        bCodon = codon.toCharArray();
        bCodon[i] = atcgOrder[k];
        synom[indices[i]-minminrt][j][k] = synom[indices[i]-minminrt][j][k] || (!isSynom(new String(aCodon), new String(bCodon)));
      }
    }
  }
}




public int getColor(float tval, double tcer) {
  return getColor(tval, tcer, 1.0f);
}

public double dMap(double val, double vlow, double vhigh, double low, double high) {
  double vnorm = val-vlow;
  vnorm = vnorm/ (vhigh-vlow);
  return (vnorm*(high-low))+low;
}

public int getColor(float tval, double tcer, float maxV) {
  //float val = map(tval,sVar.getValuef(),maxV,wedge.left*maxV,1.0);
  float val = map(tval, 0, maxV, wedge.left*maxV, 1.0f);
  if ( tval < wedge.left*maxV) {
    return bottom;
  }
  else if (val<0.0f) {
    //else if(tval<sVar.getValuef()||val<0.0){
    val = 0.0f;
  }
  else if (val>1.0f) {
    val = 1.0f;
  }

  double lcer = new BigDecimal("1E-"+sConf.getValue()).doubleValue();
  double cer = 1-tcer;
  if ( lcer == (double)1) {
    System.err.println(sConf.getValue() + " is too small.");
  }
  if (tcer>lcer) {
    cer = 0.0f;
  }
  cer = dMap(cer, 1-lcer, (double)1, (double)0, (double)1);
  if (cer<0.0f) {
    cer = 0.0f;
  }
  else if (cer>1.0f) {
    cer = 1.0f;
  }

  int cur;
  float valwt = val/(vweight);
  if ( val>=(vweight)) {
    cur = maxcolor;
  }
  else if (tval<0.0f) {
    cur = color(200);
  }
  else if (val<0.0f) {
    cur = left;
  }
  //right 90
  else if ((valwt)>.9f) {
    cur = lerpColor(right90, right, max(min(1, valwt), 0));
  }
  //right 80
  else if ((valwt)>.8f) {
    cur = lerpColor(right80, right90, max(min(1, valwt), 0));
  }
  //right 70
  else if ((valwt)>.7f) {
    cur = lerpColor(right70, right80, max(min(1, valwt), 0));
  }
  //right 60
  else if ((valwt)>.6f) {
    cur = lerpColor(right60, right70, max(min(1, valwt), 0));
  }
  //mid
  else if ((valwt)>.5f) {
    cur = lerpColor(mid, right60, max(min(1, valwt), 0));
  }
  //left 40
  else if ((valwt)>.4f) {
    cur = lerpColor(left40, mid, max(min(1, valwt), 0));
  }
  //left 30
  else if ((valwt)>.3f) {
    cur = lerpColor(left30, left40, max(min(1, valwt), 0));
  }
  //left 20
  else if ((valwt)>.2f) {
    cur = lerpColor(left20, left30, max(min(1, valwt), 0));
  }
  //left 10
  else if ((valwt)>.2f) {
    cur = lerpColor(left10, left20, max(min(1, valwt), 0));
  }
  //extreme left
  else {
    cur = lerpColor(left, left10, max(min(1, valwt), 0));
    // cur = lerpColor(left,mid,.5);
  }

  if (cer<=wedge.bottom) {
    cur = bottom;
  }
  else if (cer<wedge.top) {
    cur = lerpColor(bottom, cur, (float)cer);
  }
  return cur;
}//end getColor

//------------------------------------------------------------------
////////////////////        SAMPLING            ////////////////////
//------------------------------------------------------------------
public void sample(int samples) {
  int maxoffset = maxmaxrt-maxrt;
  int minoffset = minrt-minminrt;
  //System.err.println("r: "+rows+" c:"+ceil(float(cols-maxoffset)/samples)+ " = ("+cols+"-"+maxoffset+")/"+samples);

  vdisp = new float[ceil(PApplet.parseFloat(rows))][ceil(PApplet.parseFloat(vraw[0].length-maxoffset-minoffset)/samples)];
  pdisp = new double[ceil(PApplet.parseFloat(rows))][ceil(PApplet.parseFloat(vraw[0].length-maxoffset-minoffset)/samples)];
  covdisp = new int[ceil(PApplet.parseFloat(rows))][ceil(PApplet.parseFloat(vraw[0].length-maxoffset-minoffset)/samples)];
  vhist = new float[ceil(PApplet.parseFloat(vraw[0].length-maxoffset-minoffset)/samples)];

  float vsum;
  float curV;
  double psum;
  int covsum;
  float n = 0;
  maxcount = 0;
  maxn = 0;
  maxdip = 0;
  maxvariant =0;
  maxcovdisp = 0;
  for (int i=0;i<vdisp.length;i++) {
    for (int j=0;j<vdisp[i].length;j++) {
      vsum = 0;
      psum = 0;
      n = 0;
      covsum = 0;
      for (int k=0;k<samples;k++) {
        if ( (j*samples)+k + minoffset < vraw[i].length - maxoffset) {
          curV= getV(i, (j*samples) + k + minoffset);
          if (!Float.isNaN(curV)) {
            vsum+=curV;
            covsum+=covraw[i][ (j*samples) + k];
            n++;
            if (curV>0) {
              psum+=getP(i, j);
            }//end if
          }
        }//end if
      }//end for

      covdisp[i][j] = covsum;
      if (covdisp[i][j]>maxcovdisp) {
        maxcovdisp = covdisp[i][j];
        // System.err.println("disp: " + maxcovdisp);
      }
      vdisp[i][j] = vsum/n;
      vhist[j]+=vdisp[i][j];
      pdisp[i][j] = psum/n;

      if (vdisp[i][j]>maxvariant) {
        maxvariant = vdisp[i][j];
      }//end if
    }//end for
  }//end for
  // System.err.println("ct,n,dip: "+maxcount+","+maxn+","+maxdip);
  rows = vdisp.length;
  cols = vdisp[0].length;
}//end sample

//------------------------------------------------------------------
////////////////////      ZOOM                   ////////////////////
//------------------------------------------------------------------

//returns how much to skip in pixels
public void drawBin() {
  int binID = zoomBin;
  float curx = zoomS;
  float cury = 0;
  float h = (bh/ratio);
  float invn = 0;
  float invdip = 0;
  float amt = 0;
  int done = 0;

  pushMatrix();
  translate(xtrans+dataX, ytrans);
  int i;
  int minoffset = minrt-minminrt;
  int maxoffset = maxmaxrt-maxrt;
  int vmask = 0;
  for (int l = 0;l<rows;l++) {
    i = reorder[l];
    done++;
    curx = zoomS;
    for (int j = binID*binBasePairs + minoffset;j< (binID+1)*binBasePairs +minoffset && j<vraw[i].length-maxoffset;j++) {
      if (getV(i, j)>=0) {
        //fill(255);
        // rect(curx,i*(bh+rgap)+dataY,bpw,bh);




        double cer = sum(praw[i][j]);


        fill(getColor(getV(i, j), cer, 1.0f));

        rect(curx, cury+dataY, bpw, ratio*h);

        if (bpToIndex(refgen[i+1][j])>=0 && bpToIndex(refgen[i+1][j])!=bpToIndex(refgen[refRow+1][j])) {
          fill(actgcolor[bpToIndex(refgen[i+1][j])]);
        }
        else {
          fill(actgcolor[4]);
        }
        //System.err.println(covraw[i][j]+"/"+maxcovraw);
        //   fill(lerpColor(bottom,color(117,112,179),((float)covraw[i][j])/((float)maxcovraw)));

        //rect(curx,cury-rgap+dataY,bpw,rgap);
        rect(curx, cury+bh+dataY, bpw, rgap);
        fill(0);
        if (refgen[i+1][j]!=refgen[refRow+1][j]) {
          text(refgen[i+1][j]+"", curx+(bpw/2.0f), cury+bh+dataY+8);
        }
        else {
          text("*", curx+(bpw/2.0f), cury+bh+dataY+8);
        }
        //text(genome[j]+"",curx+(bpw/2.0),cury-rgap+dataY+7);
        if (i==0) {
          if (bpToIndex(refgen[refRow+1][j])>=0) {
            fill(actgcolor[bpToIndex(refgen[refRow+1][j])]);
            rect(curx, dataY-rgap, bpw, rgap);
            fill(0);
            text(refgen[refRow+1][j]+"", curx+(bpw/2.0f), dataY-rgap+8);
          }
          else {
            fill(actgcolor[4]);
            rect(curx, dataY-rgap, bpw, rgap);
            fill(0);
            text(refgen[refRow+1][j]+"", curx+(bpw/2.0f), dataY-rgap+8);
          }
        }
      }//end if
      curx+=bpw+cgap;
    }//end for
    cury+=bh+rgap;
  }//end for
  popMatrix();
}

public void drawSideGraph() {
  float startx = winWidth-sideGraphWidth+5;
  fill(220);
  stroke(0);
  rect(startx, dataY, sideGraphWidth-10, visibleCount*(bh+rgap)-rgap);
  float curx;
  float cury = dataY;
  float dx = 0;
  int offset = 0;
  int minoffset = minrt-minminrt;
  int maxoffset = maxmaxrt-maxrt;
  noStroke();

  if (rawcol>=minoffset && rawcol<vraw[0].length-maxoffset) {
    int i;
    for (int l = 0;l<rows;l++) {
      i = reorder[l];
    }

    for (int l = 0;l<rows;l++) {
      i = reorder[l];
      curx = startx+1;
      float scaleFactor = 0;
      if (coverageCheck.isSelected()) {
        scaleFactor = map(covraw[i][rawcol], 0, maxcovraw, 0, sideGraphWidth-11);
      }
      else {
        scaleFactor = sideGraphWidth-11;
      }

      for (int j = 0;j<vraw[i][rawcol].length;j++) {
        if (refgen[i+1][rawcol]!=atcgOrder[j]) {
          dx = vraw[i][rawcol][j]*scaleFactor;
        }
        else {
          dx = (1-sum(vraw[i][rawcol])+vraw[i][rawcol][j])*scaleFactor;
        }

        fill(actgcolor[j]);
        rect(curx, cury, dx, bh);
        if (dx>0) {
          fill(0);
          text(atcgOrder[j]+"", (dx/2.0f)+curx+textWidth(atcgOrder[j]+"")/2.0f, cury);
        }
        curx+=dx;
        if (curx>startx+sideGraphWidth-11) {
          //System.err.println("Problem " + dx);
        }
      }
      if (bpToIndex(refgen[0][rawcol])>=0) {
        fill(actgcolor[bpToIndex(refgen[0][rawcol])]);
      }
      else {
        fill(255);
      }
      //rect(curx,cury,dx,bh);

      cury+=rgap+bh;
    }
  }
  else if (col>=0 && col<cols) {
    int i;



    for (int l = 0;l<rows;l++) {
      i = reorder[l];

      float scaleFactor = 0;
      if (coverageCheck.isSelected()) {
        scaleFactor = map(covdisp[i][col], 0, maxcovdisp, 0, (sideGraphWidth-11));
      }
      else {
        scaleFactor = sideGraphWidth-11;
      }

      curx = startx+1;

      dx = vdisp[i][col]*scaleFactor;

      fill(left);
      //rect(curx,cury,sideGraphWidth-dx,bh);
      rect(curx+dx, cury, (1-vdisp[i][col])*scaleFactor, bh);
      if (dx>0) {
        fill(right);
        rect(curx, cury, vdisp[i][col]*scaleFactor, bh);
        text("var", curx+(dx/2.0f), cury);
      }
      cury+=rgap+bh;
    }
  }
  if (col>=0 || rawcol>=0) {
    fill(0);
    text("0", startx+textWidth("0")/2.0f, (rows)*(bh+rgap)+dataY);
    if (coverageCheck.isSelected()==false) {
      text("100%", width-(textWidth("100%")/2.0f)-5, (rows)*(bh+rgap)+dataY);
    }
    else if (rawcol>=0) {
      text(maxcovraw+"", width-(textWidth(maxcovraw+"")/2.0f)-5, (rows)*(bh+rgap)+dataY);
    }
    else {
      text(maxcovdisp+"", width-(textWidth(maxcovdisp+"")/2.0f)-5, (rows)*(bh+rgap)+dataY);
    }
    //text(int(maxbps)+"",winWidth-textWidth(int(maxbps)+"")/2.0,(visibleCount)*(bh+rgap)+dataY);
  }
}

public boolean isSynom(String codonA, String codonB)
{
  if (!codonlookup.containsKey(codonA)||(!codonlookup.containsKey(codonB))) {
    //System.err.println("Trouble: "+codonA+" "+codonB);
    return true;
  }
  return codonlookup.get(codonA).equals(codonlookup.get(codonB));
}

public void setupcodontable()
{	
  codonlookup = new HashMap();
  //T-----------------------
  codonlookup.put("TTT", "F");
  codonlookup.put("TTC", "F");
  codonlookup.put("TTA", "L");
  codonlookup.put("TTG", "L");

  codonlookup.put("TCT", "S");
  codonlookup.put("TCC", "S");
  codonlookup.put("TCA", "S");
  codonlookup.put("TCG", "S");

  codonlookup.put("TAT", "Y");
  codonlookup.put("TAC", "Y");
  codonlookup.put("TAA", "*");
  codonlookup.put("TAG", "*");

  codonlookup.put("TGT", "C");
  codonlookup.put("TGC", "C");
  codonlookup.put("TGA", "*");
  codonlookup.put("TGG", "W");

  //C-----------------------

  codonlookup.put("CTT", "L");
  codonlookup.put("CTC", "L");
  codonlookup.put("CTA", "L");
  codonlookup.put("CTG", "L");

  codonlookup.put("CCT", "P");
  codonlookup.put("CCC", "P");
  codonlookup.put("CCA", "P");
  codonlookup.put("CCG", "P");

  codonlookup.put("CAT", "H");
  codonlookup.put("CAC", "H");
  codonlookup.put("CAA", "Q");
  codonlookup.put("CAG", "Q");

  codonlookup.put("CGT", "R");
  codonlookup.put("CGC", "R");
  codonlookup.put("CGA", "R");
  codonlookup.put("CGG", "R");

  //A------------------------

  codonlookup.put("ATT", "I");
  codonlookup.put("ATC", "I");
  codonlookup.put("ATA", "I");
  codonlookup.put("ATG", "M");

  codonlookup.put("ACT", "T");
  codonlookup.put("ACC", "T");
  codonlookup.put("ACA", "T");
  codonlookup.put("ACG", "T");

  codonlookup.put("AAT", "N");
  codonlookup.put("AAC", "N");
  codonlookup.put("AAA", "K");
  codonlookup.put("AAG", "K");

  codonlookup.put("AGT", "S");
  codonlookup.put("AGC", "S");
  codonlookup.put("AGA", "R");
  codonlookup.put("AGG", "R");


  //G
  codonlookup.put("GTT", "V");
  codonlookup.put("GTC", "V");
  codonlookup.put("GTA", "V");
  codonlookup.put("GTG", "V");

  codonlookup.put("GCT", "A");
  codonlookup.put("GCC", "A");
  codonlookup.put("GCA", "A");
  codonlookup.put("GCG", "A");

  codonlookup.put("GAT", "D");
  codonlookup.put("GAC", "D");
  codonlookup.put("GAA", "E");
  codonlookup.put("GAG", "E");

  codonlookup.put("GGT", "G");
  codonlookup.put("GGC", "G");
  codonlookup.put("GGA", "G");
  codonlookup.put("GGG", "G");
}

public void switchrows(int row1, int row2) {
  int temp = reorder[row1];
  reorder[row1] = reorder[row2];
  reorder[row2] = temp;
  //System.err.println("switched "+row1+","+row2+" to generate "+reorder[row1]+","+reorder[row2]);
  //need to switch:
  //reference[] list
  //draw list
  //metadata
  //rowcolors
}

public float sum(float[] f) {
  float suma = 0;
  for (int i = 0;i<f.length;i++) {
    suma+=f[i];
  }
  return suma;
}

public double sum(double[] f) {
  double suma = 0;
  for (int i = 0;i<f.length;i++) {
    suma+=f[i];
  }
  return suma;
}

public float oneNorm(float[] f, float[] g) {
  float maxf = sum(f);
  float maxg = sum(g);
  if (maxf==0 || maxg== 0) {
    return -1;
  }
  float distfg = 0;

  for (int i = 0;i<f.length;i++) {
    distfg+= abs(((float)(f[i])/maxf)-((float)(g[i])/maxg));
  }
  //System.err.println(distfg);
  if (distfg>2.0f) {

    System.err.println("Problem! : " + maxf+ " " + maxg + " " + distfg + " "+f.length);
    System.err.println(f[0] + ","+ f[1] + "," + f[2] + "," + f[3]);
    System.err.println(g[0] + ","+ g[1] + "," + g[2] + "," + g[3]);
  }
  return (distfg/2.0f);
}

class Wedge {
public void setup()
{
  size(600,600);
  stroke(0);
}

float wedgeAngle  = PI * .2f;
float wedgeSize = 400;
private int wedgeX = 300;
private int wedgeY = 550;

float right = .7f;
float left = .3f;
float top = .7f;
float bottom = .3f;

int mygray=200;

//these are for the single control mouse point right now
int mx = wedgeX;
int my = wedgeY;
int mouseState = 0;

public Wedge(){
  }
  
public Wedge(int xpos,int ypos, int wsize){
    this.wedgeX = xpos; 
    this.mx = wedgeX;
    this.wedgeY = ypos; 
    this.my = wedgeY;
    this.wedgeSize = wsize;
  }  

public void setWedgeX(int xpos){
    this.wedgeX = xpos; 
    this.mx = wedgeX;
  }
  
public void setWedgeY(int ypos){
    this.wedgeY = ypos; 
    this.my = wedgeY;
  }

public float lerpAngle(float pct)
{
  return (-PI/2- (1-2*pct) * wedgeAngle);
}

public void myarc(float p1,float p2,float r)
{
  arc(wedgeX,wedgeY,wedgeSize*r,wedgeSize*r,lerpAngle(p1),lerpAngle(p2));
}

//these control the 2 yellow button positions
public float posX(float th, float r)
{
  return wedgeX + r*wedgeSize*cos(lerpAngle(th))/2;
}
public float posY(float th, float r)
{
  return wedgeY + r*wedgeSize*sin(lerpAngle(th))/2;
}

public void draw()
{
  pushStyle();
  pushMatrix();
  noStroke();
  colorMode(HSB,1.0f,1.0f,1.0f);
  
  ellipseMode(CENTER);
    fill(1, 1, .76f);
  myarc(right,1,1);
  fill(1, .84f, .76f);
  myarc(right,1,top);
  fill(1, 0.67f, .76f);
  myarc(right,1,top*4/5+bottom/5);
  fill(1, 0.50f, .77f);
  myarc(right,1,top*3/5+bottom*2/5);
  fill(1, 0.34f, .77f);
  myarc(right,1,top*2/5+bottom*3/5);
  fill(1, 0.17f, .78f);
  myarc(right,1,top/5  +bottom*4/5);
  
  //right 90 
  fill(.97f,.95f,.6f);
  myarc(left/10 + right*9/10,right,1);
  fill(.97f,.79f,.63f);
  myarc(left/10 + right*9/10,right,top);
  fill(.97f,.64f,.66f);//.2,.6,.7);
  myarc(left/10 + right*9/10,right,top*4/5+bottom/5);
  fill(.97f,.48f,.70f);//.2,.6,.7);
  myarc(left/10 + right*9/10,right,top*3/5+bottom*2/5);
  fill(.97f,.32f,.74f);//.2,.6,.7);
  myarc(left/10 + right*9/10,right,top*2/5+bottom*3/5);
  fill(.97f,.16f,.78f);//.2,.6,.7);
  myarc(left/10 + right*9/10,right,top/5+bottom*4/5);
  
  //right 80 
  fill(.99f,.90f,.7f);
  myarc(left*2/10 + right*8/10,left/10 + right*9/10,1);
  fill(.99f,.75f,.71f);
  myarc(left*2/10 + right*8/10,left/10 + right*9/10,top);
  fill(.99f,.60f,.73f);//.2,.6,.7);
  myarc(left*2/10 + right*8/10,left/10 + right*9/10,top*4/5+bottom/5);
  fill(.99f,.45f,.74f);//.2,.6,.7);
  myarc(left*2/10 + right*8/10,left/10 + right*9/10,top*3/5+bottom*2/5);
  fill(.99f,.30f,.76f);//.2,.6,.7);
  myarc(left*2/10 + right*8/10,left/10 + right*9/10,top*2/5+bottom*3/5);
  fill(.99f,.15f,.78f);//.2,.6,.7);
  myarc(left*2/10 + right*8/10,left/10 + right*9/10,top/5+bottom*4/5);
  
  //right 70
  fill(.02f,.86f,0.79f);
  myarc(left*3/10 + right*7/10,        left*2/10 + right*8/10,  1);
  fill(.02f,.72f,0.73f);
  myarc(left*3/10 + right*7/10,        left*2/10 + right*8/10,  top);
  fill(.02f,.58f,0.74f);//.2,.6,.7);
  myarc(left*3/10 + right*7/10,        left*2/10 + right*8/10,  top*4/5+bottom/5);
  fill(.02f,.44f,0.75f);//.2,.6,.7);
  myarc(left*3/10 + right*7/10,        left*2/10 + right*8/10,  top*3/5+bottom*2/5);
  fill(.02f,.29f,0.76f);//.2,.6,.7);
  myarc(left*3/10 + right*7/10,        left*2/10 + right*8/10,  top*2/5+bottom*3/5);
  fill(.02f,.14f,0.78f);//.2,.6,.7);
  myarc(left*3/10 + right*7/10,        left*2/10 + right*8/10,  top/5+bottom*4/5);
  
  //right 60
  fill(.05f,.81f,0.89f);
  myarc(left*4/10 + right*6/10,        left*3/10 + right*7/10,  1);
  fill(.05f,.67f,0.86f);
  myarc(left*4/10 + right*6/10,        left*3/10 + right*7/10,  top);
  fill(.05f,.54f,0.84f);//.2,.6,.7);
  myarc(left*4/10 + right*6/10,        left*3/10 + right*7/10,  top*4/5+bottom/5);
  fill(.05f,.40f,0.82f);//.2,.6,.7);
  myarc(left*4/10 + right*6/10,        left*3/10 + right*7/10,  top*3/5+bottom*2/5);
  fill(.05f,.27f,0.80f);//.2,.6,.7);
  myarc(left*4/10 + right*6/10,        left*3/10 + right*7/10,  top*2/5+bottom*3/5);
  fill(.05f,.13f,0.78f);//.2,.6,.7);
  myarc(left*4/10 + right*6/10,        left*3/10 + right*7/10,  top/5+bottom*4/5);
  
  //mid
  fill(.069f, .76f,0.89f);
  myarc(left*5/10 + right*5/10,        left*4/10 + right*6/10,  1);
  fill(.069f , .63f,0.86f);
  myarc(left*5/10 + right*5/10,        left*4/10 + right*6/10,  top);
  fill(.069f , .50f,0.84f);//.2,.6,.7);
  myarc(left*5/10 + right*5/10,        left*4/10 + right*6/10,  top*4/5+bottom/5);
  fill(.069f , .37f,0.82f);//.2,.6,.7);
  myarc(left*5/10 + right*5/10,        left*4/10 + right*6/10,  top*3/5+bottom*2/5);
  fill(.069f , .25f,0.80f);//.2,.6,.7);
  myarc(left*5/10 + right*5/10,        left*4/10 + right*6/10,  top*2/5+bottom*3/5);
  fill(.069f , .12f,0.78f);//.2,.6,.7);
  myarc(left*5/10 + right*5/10,        left*4/10 + right*6/10,  top/5+bottom*4/5);
  
  //left 40 
  fill(.09f,.65f,.99f);
  myarc(left*6/10 + right*4/10,        left*5/10 + right*5/10,  1);
  fill(.09f,.54f,.95f);
  myarc(left*6/10 + right*4/10,        left*5/10 + right*5/10,  top);
  fill(.09f,.43f,.90f);//.2,.6,.7);
  myarc(left*6/10 + right*4/10,        left*5/10 + right*5/10,  top*4/5+bottom/5);
  fill(.09f,.32f,.86f);//.2,.6,.7);
  myarc(left*6/10 + right*4/10,        left*5/10 + right*5/10,  top*3/5+bottom*2/5);
  fill(.09f,.22f,.82f);//.2,.6,.7);
  myarc(left*6/10 + right*4/10,        left*5/10 + right*5/10,  top*2/5+bottom*3/5);
  fill(.09f,.11f,.78f);//.2,.6,.7);
  myarc(left*6/10 + right*4/10,        left*5/10 + right*5/10,  top/5+bottom*4/5);
    
  //left 30 
  fill(.108f,.54f,.99f);
  myarc(left*7/10 + right*3/10,        left*6/10 + right*4/10,  1);
  fill(.108f,.45f,.95f);
  myarc(left*7/10 + right*3/10,        left*6/10 + right*4/10,  top);
  fill(.108f,.36f,.90f);//.2,.6,.7);
  myarc(left*7/10 + right*3/10,        left*6/10 + right*4/10,  top*4/5+bottom/5);
  fill(.108f,.27f,.86f);//.2,.6,.7);
  myarc(left*7/10 + right*3/10,        left*6/10 + right*4/10,  top*3/5+bottom*2/5);
  fill(.108f,.18f,.82f);//.2,.6,.7);
  myarc(left*7/10 + right*3/10,        left*6/10 + right*4/10,  top*2/5+bottom*3/5);
  fill(.108f,.09f,.78f);//.2,.6,.7);
  myarc(left*7/10 + right*3/10,        left*6/10 + right*4/10,  top/5+bottom*4/5);
  
  //left 20  
  fill(.128f,.42f,1);
  myarc(left*8/10 + right*2/10,        left*7/10 + right*3/10,  1);
  fill(.128f,.35f,.96f);
  myarc(left*8/10 + right*2/10,        left*7/10 + right*3/10,  top);
  fill(.128f,.28f,.91f);//.2,.6,.7);
  myarc(left*8/10 + right*2/10,        left*7/10 + right*3/10,  top*4/5+bottom/5);
  fill(.128f,.21f,.87f);//.2,.6,.7);
  myarc(left*8/10 + right*2/10,        left*7/10 + right*3/10,  top*3/5+bottom*2/5);
  fill(.128f,.14f,.82f);//.2,.6,.7);
  myarc(left*8/10 + right*2/10,        left*7/10 + right*3/10,  top*2/5+bottom*3/5);
  fill(.128f,.07f,.78f);//.2,.6,.7);
  myarc(left*8/10 + right*2/10,        left*7/10 + right*3/10,  top/5+bottom*4/5);
  
  //left 10  
  fill(.147f,.31f,1);
  myarc(left*9/10 + right/10,        left*8/10 + right*2/10,  1);
  fill(.147f,.26f,.96f);
  myarc(left*9/10 + right/10,        left*8/10 + right*2/10,  top);
  fill(.147f,.21f,.91f);//.2,.6,.7);
  myarc(left*9/10 + right/10,        left*8/10 + right*2/10,  top*4/5+bottom/5);
  fill(.147f,.16f,.87f);//.2,.6,.7);
  myarc(left*9/10 + right/10,        left*8/10 + right*2/10,  top*3/5+bottom*2/5);
  fill(.147f,.11f,.82f);//.2,.6,.7);
  myarc(left*9/10 + right/10,        left*8/10 + right*2/10,  top*2/5+bottom*3/5);
  fill(.147f,.05f,.78f);//.2,.6,.7);
  myarc(left*9/10 + right/10,        left*8/10 + right*2/10,  top/5+bottom*4/5);  
  
  //left 
  fill(.167f,.2f,1);
  myarc(left,  left*9/10 + right/10,  1);
  fill(.167f,.17f,0.96f);
  myarc(left,  left*9/10 + right/10,  top);
  fill(.167f,.14f,0.91f);//.2,.6,.7);
  myarc(left,  left*9/10 + right/10,  top*4/5+bottom/5);
  fill(.167f,.10f,0.87f);//.2,.6,.7);
  myarc(left,  left*9/10 + right/10,  top*3/5+bottom*2/5);
  fill(.167f,.07f,0.82f);//.2,.6,.7);
  myarc(left,  left*9/10 + right/10,  top*2/5+bottom*3/5);
  fill(.167f,.03f,0.78f);//.2,.6,.7);
  myarc(left,  left*9/10 + right/10,  top/5+bottom*4/5);
  
  fill(0,0,.7f);
  myarc(0,1,bottom);
  
  colorMode(RGB,1.0f,1.0f,1.0f);
  fill(1,1,0);
  int rad1 = 10;
  int rad2 = 10;
  if(mouseState==1){
    rad1 = 15;
  }
  else if(mouseState==2){
    rad2 = 15;
  }
  ellipse(posX(right,top),posY(right,top),rad1,rad1);
  ellipse(posX(left,bottom),posY(left,bottom),rad2,rad2);
  if(mouseState>0){
   // ellipse(mx,my,9,9);
  }
  popMatrix();
  popStyle();
}

public void mousePressedAlt(float mX,float mY)
{
  if ((abs(posX(right,top)-mX) < 20) &&
      (abs(posY(right,top)-mY) < 20)) {
    mouseState = 1;
      }
  if ((abs(posX(left,bottom)-mX) < 20) &&
      (abs(posY(left,bottom)-mY) < 20)) {
    mouseState = 2;
      }
}
public void mouseReleasedAlt()
{
  mouseState = 0;
}

public void mouseDraggedAlt(float nx,float ny)
{
  mx = PApplet.parseInt(nx);
  my = PApplet.parseInt(ny);  

  float fx = PApplet.parseFloat(mx-wedgeX);
  float fy = PApplet.parseFloat(wedgeY-my);
  
  float r = sqrt(fx*fx+fy*fy)/wedgeSize*2;
  float a = atan2(fy,fx);
  
  a = 1-(1+(a-PI/2)/wedgeAngle)/2;
  
  if (a<0) a = 0;
  if (a>1) a = 1;
  if (r<0) r = 0;
  if (r>1) r = 1;
  
  if (mouseState == 1) {
    right = a;
    top = r;
    
    if (left>right) left=right;
    if (bottom>top) bottom=top;
  }
  if (mouseState == 2) {
    left = a;
    bottom = r;
    
    if(right<left) right=left;
    if(top<bottom) top=bottom;
  }
}


}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "LayerCake" });
  }
}
